//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include "TStamp.h"
#include "TStamper.h"
//---------------------------------------------------------------------------
struct TViewOptions
{
	bool MenuIcons;
	bool SwapPanels;
	bool StatusBar;
	bool Topmost;
	bool LastPosition;
	__fastcall TViewOptions();
	__fastcall virtual ~TViewOptions();
	bool __fastcall operator==(const TViewOptions& ASrc) const;
	bool __fastcall operator!=(const TViewOptions& ASrc) const;
};
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TPanel *ClientPanel;
	TPanel *BasePanel;
	TPanel *LeftPanel;
	TPanel *RightPanel;
	TPanel *GetPanel;
	TPanel *SetPanel;
	TPanel *SyncPanel;
	TPaintBox *GetPaintBox;
	TPaintBox *SetPaintBox;
	TPaintBox *SyncPaintBox;
	TLabel *GetLabel;
	TLabel *SetLabel;
	TLabel *SyncLabel;
	TCheckBox *CRTimeCheckBox;
	TCheckBox *LWTimeCheckBox;
	TCheckBox *LATimeCheckBox;
	TCheckBox *SubdirsCheckBox;
	TCheckBox *DirectoriesCheckBox;
	TCheckBox *AnyAttrCheckBox;
	TStatusBar *StatusBar;
	TImageList *MenuImages;
	TMainMenu *FormMainMenu;
	TMenuItem *FunctionsMenuItem;
	TMenuItem *NewWindowMenuItem;
	TMenuItem *UndoMenuItem;
	TMenuItem *RedoMenuItem;
	TMenuItem *CopyErrorLogMenuItem;
	TMenuItem *PropertiesMenuItem;
	TMenuItem *OptionsMenuItem;
	TMenuItem *ClearUndoRedoDataMenuItem;
	TMenuItem *ClearGetDataMenuItem;
	TMenuItem *MenuIconsMenuItem;
	TMenuItem *SwapPanelsMenuItem;
	TMenuItem *StatusBarMenuItem;
	TMenuItem *TopmostMenuItem;
	TMenuItem *LastPositionMenuItem;
	TMenuItem *DefaultMenuItem;
	TMenuItem *ExitMenuItem;
	TMenuItem *Help1MenuItem;
	TMenuItem *Help2MenuItem;
	TMenuItem *TipsMenuItem;
	TMenuItem *AboutMenuItem;
	TPopupMenu *FormPopupMenu;
	TMenuItem *NewWindowPMenuItem;
	TMenuItem *UndoPMenuItem;
	TMenuItem *RedoPMenuItem;
	TMenuItem *CopyErrorLogPMenuItem;
	TMenuItem *PropertiesPMenuItem;
	TMenuItem *MenuItem1;
	TMenuItem *MenuItem2;
	TMenuItem *MenuItem3;
	TMenuItem *MenuItem4;
	TMenuItem *MenuItem5;
	TMenuItem *MenuItem6;
	TMenuItem *MenuItem7;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall CheckBoxClick(TObject *Sender);
	void __fastcall StatusBarDblClick(TObject *Sender);
	void __fastcall PaintBoxPaint(TObject *Sender);
	void __fastcall MenuItemClick(TObject *Sender);
	void __fastcall HolderChange(TObject *Sender);
	void __fastcall HistoryChange(TObject *Sender);
	void __fastcall ErrorLogChange(TObject *Sender);
	void __fastcall StampOptionsChange(TObject *Sender);
	void __fastcall ViewOptionsChange(TObject *Sender);
	void __fastcall ThreadChange(TObject *Sender);
	void __fastcall StatusChange(TObject *Sender);
	void __fastcall StamperTerminate(TObject *Sender);
private:
	TStampHolder* FHolder;
	TStampHistory* FHistory;
	AnsiString FErrorLog;
	TStampOptions FStampOptions;
	TViewOptions FViewOptions;
	TThread* FThread;
	int FStatusCount;
	AnsiString FStatusText;
	void __fastcall SetErrorLog(AnsiString AErrorLog);
	void __fastcall SetStampOptions(TStampOptions AStampOptions);
	void __fastcall SetViewOptions(TViewOptions AViewOptions);
	void __fastcall SetThread(TThread* AThread);
	void __fastcall ShowStatus(int AStatusCount, AnsiString AStatusText);
	void __fastcall FilesDropped(TStrings* AFilePaths, TPoint AScreenPoint);
	void __fastcall Process(TStamper::ID AId, TStrings* AFilePaths);
	void __fastcall Cancel();
	bool __fastcall IsProcessing(bool AShowMessage = false) const;
	void __fastcall LowerPanel(TPanel* APanel);
	void __fastcall EnableControls(TControl* AControl, bool AEnabled) const;
	int __fastcall FindParam(AnsiString AParam, bool ACaseSensitive) const;
	void __fastcall DefaultSettings();
	void __fastcall LoadSettings();
	void __fastcall SaveSettings();
	__property AnsiString ErrorLog = {read=FErrorLog, write=SetErrorLog};
	__property TStampOptions StampOptions = {read=FStampOptions, write=SetStampOptions};
	__property TViewOptions ViewOptions = {read=FViewOptions, write=SetViewOptions};
	__property TThread* Thread = {read=FThread, write=SetThread};
	__property int StatusCount = {read=FStatusCount};
	__property AnsiString StatusText = {read=FStatusText};
protected:
	void __fastcall WMDropFiles(TWMDropFiles& AMessage);
public:
	__fastcall TMainForm(TComponent* Owner);
	__fastcall virtual ~TMainForm();

	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif

