//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TStamp.h"
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// struct TStamp
//---------------------------------------------------------------------------
__fastcall TStamp::TStamp()
{
	CRTime.dwLowDateTime = CRTime.dwHighDateTime = 0;
	LWTime = LATime = CRTime;
}
//---------------------------------------------------------------------------
__fastcall TStamp::~TStamp()
{
	// do nohting
}
//---------------------------------------------------------------------------
bool __fastcall TStamp::operator==(const TStamp& ASrc) const
{
	return FilePath == ASrc.FilePath &&
		CompareFileTime(&CRTime, &ASrc.CRTime) == 0 &&
		CompareFileTime(&LWTime, &ASrc.LWTime) == 0 &&
		CompareFileTime(&LATime, &ASrc.LATime) == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TStamp::operator!=(const TStamp& ASrc) const
{
	return !(*this == ASrc);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// struct TStampOptions
//---------------------------------------------------------------------------
__fastcall TStampOptions::TStampOptions() : Subdirs(true), Directories(true),
	AnyAttr(false), CRTime(true), LWTime(true), LATime(true)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TStampOptions::~TStampOptions()
{
	// do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TStampOptions::operator==(const TStampOptions& ASrc) const
{
	return Subdirs == ASrc.Subdirs &&
		Directories == ASrc.Directories &&
		AnyAttr == ASrc.AnyAttr &&
		CRTime == ASrc.CRTime &&
		LWTime == ASrc.LWTime &&
		LATime == ASrc.LATime;
}
//---------------------------------------------------------------------------
bool __fastcall TStampOptions::operator!=(const TStampOptions& ASrc) const
{
	return !(*this == ASrc);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// struct TStampUnit
//---------------------------------------------------------------------------
__fastcall TStampUnit::TStampUnit()
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TStampUnit::~TStampUnit()
{
	// do nothing
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// class TStampHolder : public TObject
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
const TStamps& __fastcall TStampHolder::GetStamps() const
{
	return FStamps;
}
//---------------------------------------------------------------------------
const TStamp& __fastcall TStampHolder::GetAverage() const
{
	return FAverage;
}
//---------------------------------------------------------------------------
int __fastcall TStampHolder::GetCount() const
{
	return static_cast<int>(FStamps.size());
}
//---------------------------------------------------------------------------
int __fastcall TStampHolder::GetFileCount() const
{
	return Count - DirCount;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
void __fastcall TStampHolder::DoChange()
{
	if(FOnChange != NULL) FOnChange(this);
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TStampHolder::TStampHolder() : TObject(), FDirCount(0), FOnChange(NULL)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TStampHolder::~TStampHolder()
{
	// do nothing
}
//---------------------------------------------------------------------------
void __fastcall TStampHolder::Set(const TStamps& AStamps, const TStamp& AAverage, int ADirCount)
{
	FStamps = AStamps;
	FAverage = AAverage;
	FDirCount = ADirCount;
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TStampHolder::Clear()
{
	FStamps.clear();
	FAverage = TStamp();
	FDirCount = 0;
	DoChange();
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// class TStampHistory : public TObject
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
const TStampUnit& __fastcall TStampHistory::GetUndoValue() const
{
	return FValues[FIndex - 1];
}
//---------------------------------------------------------------------------
const TStampUnit& __fastcall TStampHistory::GetRedoValue() const
{
	return FValues[FIndex];
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::DoChange()
{
	if(FOnChange != NULL) FOnChange(this);
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TStampHistory::TStampHistory() : TObject(), FIndex(0), FOnChange(NULL)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TStampHistory::~TStampHistory()
{
	// do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TStampHistory::CanUndo() const
{
	return FIndex > 0;
}
//---------------------------------------------------------------------------
bool __fastcall TStampHistory::CanRedo() const
{
	return FIndex < FValues.size();
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::Add(const TStampUnit& ASet)
{
	FValues.resize(FIndex++);
	FValues.push_back(ASet);
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::Undo(const TStampUnit& ASet)
{
	if(!CanUndo()) return;

	FValues[--FIndex] = ASet;
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::Redo(const TStampUnit& ASet)
{
	if(!CanRedo()) return;

	FValues[FIndex++] = ASet;
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::RemoveUndoValue()
{
	if(!CanUndo()) return;

	FValues.erase(FValues.begin() + --FIndex);
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::RemoveRedoValue()
{
	if(!CanRedo()) return;

	FValues.erase(FValues.begin() + FIndex);
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TStampHistory::Clear()
{
	FValues.clear();
	FIndex = 0;
	DoChange();
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
bool __fastcall IsValidFileTime(const FILETIME& AFileTime)
{
	return !(AFileTime.dwLowDateTime == 0 && AFileTime.dwHighDateTime == 0) &&
		(static_cast<DWORDLONG>(AFileTime.dwHighDateTime) << DWORD_BIT) +
		AFileTime.dwLowDateTime < 0x8000000000000000;
}
//---------------------------------------------------------------------------
void __fastcall ClearFileTime(FILETIME& AFileTime)
{
	AFileTime.dwLowDateTime = AFileTime.dwHighDateTime = 0;
}
//---------------------------------------------------------------------------
DWORDLONG __fastcall FileTimeToDwordLong(const FILETIME& AFileTime)
{
	return (static_cast<DWORDLONG>(AFileTime.dwHighDateTime) << DWORD_BIT) +
		AFileTime.dwLowDateTime;
}
//---------------------------------------------------------------------------
FILETIME __fastcall DwordLongToFileTime(DWORDLONG ADwordLong)
{
	FILETIME fileTime;
	fileTime.dwLowDateTime = static_cast<DWORD>(ADwordLong);
	fileTime.dwHighDateTime = static_cast<DWORD>(ADwordLong >> DWORD_BIT);

	return fileTime;
}
//---------------------------------------------------------------------------

