//---------------------------------------------------------------------------
#ifndef TStamperH
#define TStamperH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "TStamperBase.h"
//---------------------------------------------------------------------------
class TStamper : public TStamperBase
{
public:
	enum ID {ID_GET, ID_SET, ID_SYNC, ID_UNDO, ID_REDO, ID_PROPERTIES};
private:
	int FTotal;
	int FSuccess;
	bool FCanceled;
	TStringList* FErrorLog;
	ID FId;
	TStringList* FFilePaths;
	TStampHolder* FHolder;
	TStampHistory* FHistory;
	TStampOptions FOptions;
	TList* FParams;
	bool __fastcall Execute_CheckConditions();
	bool __fastcall Execute_FilePaths();
	void __fastcall Execute_Get();
	void __fastcall Execute_Get_GetProperties();
	void __fastcall Execute_Get_Update();
	void __fastcall Execute_Set();
	void __fastcall Execute_Set_GetStampUnit();
	void __fastcall Execute_Set_SetToHistory();
protected:
	void __fastcall Execute();
	void __fastcall DoTerminate();
public:
	__fastcall TStamper(ID AId, TStrings* AFilePaths, TStampHolder* AHolder,
		TStampHistory* AHistory, TStampOptions AOptions);
	__fastcall virtual ~TStamper();
	static AnsiString __fastcall IdToName(ID AId);
	__property int Total = {read=FTotal};
	__property int Success = {read=FSuccess};
	__property bool Canceled = {read=FCanceled};
	__property TStringList* ErrorLog = {read=FErrorLog};
	__property ID Id = {read=FId};
};
//---------------------------------------------------------------------------
#endif
 