//---------------------------------------------------------------------------
#ifndef TStamperBaseH
#define TStamperBaseH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "TStamp.h"
//---------------------------------------------------------------------------
class TStamperBase : public TThread
{
private:
	AnsiString FMessageBoxText;
	int FMessageBoxFlags;
	int FMessageBoxResult;
	AnsiString __fastcall FilePathToDisplayName(const AnsiString& AFilePath) const;
	void __fastcall AddSubdirs(TStrings* AFilePaths, const AnsiString& AFilePath, const TStampOptions& AOptions) const;
	AnsiString __fastcall AttrsToStr(DWORD AAttrs) const;
	bool __fastcall CalculateSum(DWORD* ASum, int ASize, const FILETIME& AFileTime) const;
	void __fastcall CalculateSum(DWORD* ASum, int ASize, int APosition, DWORD AValue) const;
	void __fastcall CalculateAverage(FILETIME& AFileTime, DWORD* ASum, int ASize, int ATotal) const;
	void __fastcall ShowMessageBox_GetResult();
protected:
	void __fastcall PrepareFilePaths(TStrings* AFilePaths, TStampOptions AOptions) const;
	void __fastcall TrimStamps(TStamps& AStamps, const bool* AValid) const;
	int __fastcall Get(TStrings* AErrorLog, TStamps& AStamps, int& ADirCount) const;
	int __fastcall Get(TStrings* AErrorLog, TStamps& AStamps, int& ADirCount, bool* AValid) const;
	int __fastcall Set(TStrings* AErrorLog, const TStamps& AStamps, TStampOptions AOptions, bool AForward, bool* AValid) const;
	void __fastcall ShowProperties(int AFileCount, int ADirCount, const TStamp& AAverage);
	TStamp __fastcall StampsToAverage(const TStamps& AStamps) const;
	int __fastcall ShowMessageBox(const AnsiString& AText, int AFlags);
public:
	__fastcall TStamperBase(); // @CONSTRUCTOR
	__fastcall virtual ~TStamperBase();
};
//---------------------------------------------------------------------------
// @CONSTRUCTOR
// Suspended = true
// FreeOnTerminate = true
//---------------------------------------------------------------------------
#endif
