//---------------------------------------------------------------------------
#ifndef TStamperThreadH
#define TStamperThreadH
#include <Classes.hpp>
#include "TStamper.h"
//---------------------------------------------------------------------------
class TStamperThread : public TThread
{
private:                                           

protected:
	TResults FResults;
	TStringList* FErrorBuffer;

	AnsiString __fastcall GetErrorLog() const;

	void __fastcall Execute();
	bool __fastcall Get(TFileInfo& AFileInfo, TStringList* AErrorBuffer = NULL) const;
	bool __fastcall Set(const TFileInfo& AFileInfo, TStringList* AErrorBuffer = NULL) const;
	int __fastcall CountDirs(const TFileInfos& AFileInfos) const;
	void __fastcall Average(TFileInfo& AAverage, const TFileInfos& AFileInfos) const;
	bool __fastcall CalculateSum(DWORD* ASum, int ASize, const FILETIME& AFileTime) const;
	void __fastcall CalculateSum(DWORD* ASum, int ASize, int APosition, DWORD AValue) const;
	void __fastcall CalculateAverage(FILETIME& AFileTime, DWORD* ASum, int ASize, int ATotal) const;

public:
	__fastcall TStamperThread(); // @CONSTRUCTOR
	__fastcall virtual ~TStamperThread();

	static bool __fastcall IsValidFileTime(const FILETIME& AFileTime);
	static void __fastcall ClearFileTime(FILETIME& AFileTime);

	__property TResults Results = {read=FResults};
	__property AnsiString ErrorLog = {read=GetErrorLog};
};
//---------------------------------------------------------------------------
// DESCRIPTION
// base class for those that work with TStamper
//
// @CONSTRUCTOR
// properties are set as following
//   this->CeateSuspended = true
//   this->FreeOnTerminate = false
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
class TFileGetThread : public TStamperThread
{
private:
	TFileInfos FFileInfos;
	TFileGetData FFileGetData;

protected:
	void __fastcall Execute();

public:
	__fastcall TFileGetThread(const TFileInfos& AFileInfos);
	__fastcall virtual ~TFileGetThread();

	__property TFileGetData FileGetData = {read=FFileGetData};
};
//---------------------------------------------------------------------------
class TFileSetThread : public TStamperThread
{
private:
	TFileInfos FFileInfos;
	bool FForward;

protected:
	void __fastcall Execute();

public:
	__fastcall TFileSetThread(const TFileInfos& AFileInfos, bool AForward);
	__fastcall virtual ~TFileSetThread();
};
//---------------------------------------------------------------------------
#endif

